#ifndef TEXT_H
#define TEXT_H
#include "SDL_ttf.h"
#include "SDL.h"
#include "util.h"

#define CACHE_SIZE 10
#define MAX_STRING_SIZE 500

class Text {
public:
    TTF_Font *huge;
    TTF_Font *normal;
    TTF_Font *small;
    SDL_Surface *cache[CACHE_SIZE];
    char cache_string[CACHE_SIZE][MAX_STRING_SIZE];

    Text();
    ~Text() {
	TTF_CloseFont(huge);
	TTF_CloseFont(normal);
	TTF_CloseFont(small);
    }
    void resize(float f);
    void reset_cache();

    int drawtext_cache(const char * t, SDL_Surface *surf, int x, int y, SDL_Color c, TTF_Font *f, int halign, int valign, int cid);
    int drawtext(const char * t, SDL_Surface *surf, int x, int y, SDL_Color c, TTF_Font *f, int halign, int valign);
    void drawtext(const char * t, SDL_Surface *surf, int x, int y, SDL_Color c, TTF_Font *f);
    SDL_Surface* rendertext(const char * t, SDL_Color c, TTF_Font *f);
    inline int drawrenderedtext(SDL_Surface *text, SDL_Surface *surf, int x, int y, int halign, int valign);
};

#endif